# Scales are in mm for translations, rad for rotations

#-----------------------------------------
# Scale of misalignments for the modules
#-----------------------------------------
velomod_trans = [0.0, 0.0, 0.0]
velomod_rot   = [0.0, 0.0, 0.0]

#-----------------------------------------
# Scale of misalignments for the sensors 
#-----------------------------------------
velodet_trans = [0.0, 0.0, 0.0]
velodet_rot   = [0.0, 0.0, 0.0]

#-----------------------------------------
# Scale of misalignments for the halves
#-----------------------------------------
veloleft_trans =  [0.0, 0.0, 0.0]
veloleft_rot   =  [0.0, 0.0, 0.0]
veloright_trans = [0.0, 0.0, 0.0]
veloright_rot   = [0.0, 0.0, 0.0]

#--------------------------------------------
# Scale of misalignments for the Global VELO
#--------------------------------------------
veloglo_trans = [0.0, 0.0, 0.0]
veloglo_rot   = [0.0, 0.0, 0.0]

#--------------------------------------------
# Scale of misalignments for the IT and OT 
#--------------------------------------------
# Globalt
tglo_etrans = [0.0, 0.0, 0.0]
tglo_erot   = [0.0, 0.0, 0.0]
tglo_trans_tot = [0.0, 0.0, 0.0]
tglo_rot_tot   = [0.0, 0.0, 0.0]
tglo_lasttrans = [0.0, 0.0, 0.0]
tglo_lastrot   = [0.0, 0.0, 0.0]

# Stations
tstat_trans = [0.0, 0.0, 0.0]
tstat_rot   = [0.0, 0.0, 0.0]


#----------------------------------------
# Fitted translations and rotations
#----------------------------------------

rotPars    = [0.0, 0.0, 0.0]
transPars  = [0.0, 0.0, 0.0]
erotPars   = [0.0, 0.0, 0.0]
etransPars = [0.0, 0.0, 0.0]

fitflags = [ 0, 0, 0, 0, 0, 0]
fitStatus = 0

#----------------------------------------------
#   Set Various Switches & Parameters
#----------------------------------------------
# 

verbose = False          #Printing debugging info 

writeAlignFile = True    #Produce output ROOT Alignment Files

myFitFunc = 'Gauss2'     # Fitting function, "Gauss2" or "Gauss3"

#-------------------- Database updating --------------------
#
# dbUpdate = 0 ==> Don't write to DB at all
# dbUpdate = 1 ==> Only write the initial and final alignmenets
# dbUpdate = 2 ==> Write the initial and final alignments and all iterations
#
dbUpdate = 0   
loadDB = False

# Minimum number of events for alignment algorithm
minNumberEv = 0

# Switches to control what gets executed
procFixed = False
procRandom = False
procData = False

# Simulation of fixed misalignment, when procFixed = True
#translation = [2.0, 1.0, 10.0]
#rotation = [0.002, -0.002, 0.004]
translation = [0.0, 0.0, 0.0]
rotation = [0.002, -0.002, 0.0]

# Maximum translational (mm) & rotational (rad) deviations between VELO and T-Station match (in mm)
# which are unphysical
max_dx_value = 10.0
max_dy_value = 10.0
max_dz_value = 100.0

max_da_value = 0.004
max_db_value = 0.004
max_dg_value = 0.020

# Maximum translational deviations between VELO and T-Station match (in mm)
accept_dx_value = 0.05
accept_dy_value = 0.10
accept_dz_value = 2.0
# Maximum deviations (significance) between VELO and T-Station match
accept_dxs_value = 3.0
accept_dys_value = 3.0
accept_dzs_value = 3.0

# Maximum rotational deviations between VELO and T-Station match (in mrad)
accept_da_value = 0.2e-3
accept_db_value = 0.2e-3
accept_dg_value = 0.5e-3
# Maximum deviations (significance) between VELO and T-Station match
accept_das_value = 3.0
accept_dbs_value = 3.0
accept_dgs_value = 3.0


max_dzmag_value = 10.0
max_dzmags_value = 5.0

#================================================

defInputPars = [10.0, 0.001, 0.0, 200.0, 4.0, 50.0,10.0]
defRange = [-50.0, 50.0]
defLimMin = [0.0, -10.0, -10000.0, 0.0,    0.05,  0.0,    0.05]
defLimMax = [0.0,  10.0,  10000.0, 1.0e12, 500.0, 1.0e12, 500.]
defFuncOpt = 'REBQ'

InputPars = [10.0, 0.001, 0.0, 200.0, 4.0, 50.0,10.0]
Range = [-50.0, 50.0]
LimMin = [0.0, -10.0, -10000.0, 0.0,    0.05,  0.0,    0.05]
LimMax = [0.0,  10.0,  10000.0, 1.0e12, 500.0, 1.0e12, 500.]
FuncOpt = 'REBQ'

# Other constants

pminCut = 6.0

minITHits = 8
minOTHits = 12
